// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/BrakeDiagnostics.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__BRAKE_DIAGNOSTICS__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__BRAKE_DIAGNOSTICS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__BrakeDiagnostics __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__BrakeDiagnostics __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BrakeDiagnostics_
{
  using Type = BrakeDiagnostics_<ContainerAllocator>;

  explicit BrakeDiagnostics_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->degraded = false;
      this->degraded_cmd_type = false;
      this->degraded_comms = false;
      this->degraded_comms_dbw = false;
      this->degraded_comms_dbw_gateway = false;
      this->degraded_comms_dbw_steer = false;
      this->degraded_comms_dbw_thrtl = false;
      this->degraded_comms_dbw_gear = false;
      this->degraded_comms_vehicle = false;
      this->degraded_comms_actuator = false;
      this->degraded_comms_actuator_1 = false;
      this->degraded_comms_actuator_2 = false;
      this->degraded_internal = false;
      this->degraded_control_performance = false;
      this->degraded_param_mismatch = false;
      this->degraded_btsi_stuck_low = false;
      this->degraded_btsi_stuck_high = false;
      this->degraded_vehicle = false;
      this->degraded_vehicle_speed = false;
      this->degraded_actuator = false;
      this->degraded_actuator_1 = false;
      this->degraded_actuator_2 = false;
      this->degraded_actuator_aeb_deny = false;
      this->degraded_calibration = false;
      this->fault = false;
      this->fault_power = false;
      this->fault_comms = false;
      this->fault_internal = false;
      this->fault_vehicle = false;
      this->fault_actuator = false;
      this->fault_comms_dbw = false;
      this->fault_comms_dbw_gateway = false;
      this->fault_comms_dbw_steer = false;
      this->fault_comms_dbw_thrtl = false;
      this->fault_comms_dbw_gear = false;
      this->fault_comms_vehicle = false;
      this->fault_comms_actuator = false;
      this->fault_comms_actuator_1 = false;
      this->fault_comms_actuator_2 = false;
      this->fault_vehicle_speed = false;
      this->fault_actuator_acc_deny = false;
      this->fault_actuator_pedal_sensor = false;
      this->fault_bped_sensor_1 = false;
      this->fault_bped_sensor_2 = false;
      this->fault_bped_sensor_mismatch = false;
      this->fault_actuator_1 = false;
      this->fault_actuator_2 = false;
      this->fault_control_performance = false;
      this->fault_param_mismatch = false;
      this->fault_param_limits = false;
      this->fault_calibration = false;
    }
  }

  explicit BrakeDiagnostics_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->degraded = false;
      this->degraded_cmd_type = false;
      this->degraded_comms = false;
      this->degraded_comms_dbw = false;
      this->degraded_comms_dbw_gateway = false;
      this->degraded_comms_dbw_steer = false;
      this->degraded_comms_dbw_thrtl = false;
      this->degraded_comms_dbw_gear = false;
      this->degraded_comms_vehicle = false;
      this->degraded_comms_actuator = false;
      this->degraded_comms_actuator_1 = false;
      this->degraded_comms_actuator_2 = false;
      this->degraded_internal = false;
      this->degraded_control_performance = false;
      this->degraded_param_mismatch = false;
      this->degraded_btsi_stuck_low = false;
      this->degraded_btsi_stuck_high = false;
      this->degraded_vehicle = false;
      this->degraded_vehicle_speed = false;
      this->degraded_actuator = false;
      this->degraded_actuator_1 = false;
      this->degraded_actuator_2 = false;
      this->degraded_actuator_aeb_deny = false;
      this->degraded_calibration = false;
      this->fault = false;
      this->fault_power = false;
      this->fault_comms = false;
      this->fault_internal = false;
      this->fault_vehicle = false;
      this->fault_actuator = false;
      this->fault_comms_dbw = false;
      this->fault_comms_dbw_gateway = false;
      this->fault_comms_dbw_steer = false;
      this->fault_comms_dbw_thrtl = false;
      this->fault_comms_dbw_gear = false;
      this->fault_comms_vehicle = false;
      this->fault_comms_actuator = false;
      this->fault_comms_actuator_1 = false;
      this->fault_comms_actuator_2 = false;
      this->fault_vehicle_speed = false;
      this->fault_actuator_acc_deny = false;
      this->fault_actuator_pedal_sensor = false;
      this->fault_bped_sensor_1 = false;
      this->fault_bped_sensor_2 = false;
      this->fault_bped_sensor_mismatch = false;
      this->fault_actuator_1 = false;
      this->fault_actuator_2 = false;
      this->fault_control_performance = false;
      this->fault_param_mismatch = false;
      this->fault_param_limits = false;
      this->fault_calibration = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _degraded_type =
    bool;
  _degraded_type degraded;
  using _degraded_cmd_type_type =
    bool;
  _degraded_cmd_type_type degraded_cmd_type;
  using _degraded_comms_type =
    bool;
  _degraded_comms_type degraded_comms;
  using _degraded_comms_dbw_type =
    bool;
  _degraded_comms_dbw_type degraded_comms_dbw;
  using _degraded_comms_dbw_gateway_type =
    bool;
  _degraded_comms_dbw_gateway_type degraded_comms_dbw_gateway;
  using _degraded_comms_dbw_steer_type =
    bool;
  _degraded_comms_dbw_steer_type degraded_comms_dbw_steer;
  using _degraded_comms_dbw_thrtl_type =
    bool;
  _degraded_comms_dbw_thrtl_type degraded_comms_dbw_thrtl;
  using _degraded_comms_dbw_gear_type =
    bool;
  _degraded_comms_dbw_gear_type degraded_comms_dbw_gear;
  using _degraded_comms_vehicle_type =
    bool;
  _degraded_comms_vehicle_type degraded_comms_vehicle;
  using _degraded_comms_actuator_type =
    bool;
  _degraded_comms_actuator_type degraded_comms_actuator;
  using _degraded_comms_actuator_1_type =
    bool;
  _degraded_comms_actuator_1_type degraded_comms_actuator_1;
  using _degraded_comms_actuator_2_type =
    bool;
  _degraded_comms_actuator_2_type degraded_comms_actuator_2;
  using _degraded_internal_type =
    bool;
  _degraded_internal_type degraded_internal;
  using _degraded_control_performance_type =
    bool;
  _degraded_control_performance_type degraded_control_performance;
  using _degraded_param_mismatch_type =
    bool;
  _degraded_param_mismatch_type degraded_param_mismatch;
  using _degraded_btsi_stuck_low_type =
    bool;
  _degraded_btsi_stuck_low_type degraded_btsi_stuck_low;
  using _degraded_btsi_stuck_high_type =
    bool;
  _degraded_btsi_stuck_high_type degraded_btsi_stuck_high;
  using _degraded_vehicle_type =
    bool;
  _degraded_vehicle_type degraded_vehicle;
  using _degraded_vehicle_speed_type =
    bool;
  _degraded_vehicle_speed_type degraded_vehicle_speed;
  using _degraded_actuator_type =
    bool;
  _degraded_actuator_type degraded_actuator;
  using _degraded_actuator_1_type =
    bool;
  _degraded_actuator_1_type degraded_actuator_1;
  using _degraded_actuator_2_type =
    bool;
  _degraded_actuator_2_type degraded_actuator_2;
  using _degraded_actuator_aeb_deny_type =
    bool;
  _degraded_actuator_aeb_deny_type degraded_actuator_aeb_deny;
  using _degraded_calibration_type =
    bool;
  _degraded_calibration_type degraded_calibration;
  using _fault_type =
    bool;
  _fault_type fault;
  using _fault_power_type =
    bool;
  _fault_power_type fault_power;
  using _fault_comms_type =
    bool;
  _fault_comms_type fault_comms;
  using _fault_internal_type =
    bool;
  _fault_internal_type fault_internal;
  using _fault_vehicle_type =
    bool;
  _fault_vehicle_type fault_vehicle;
  using _fault_actuator_type =
    bool;
  _fault_actuator_type fault_actuator;
  using _fault_comms_dbw_type =
    bool;
  _fault_comms_dbw_type fault_comms_dbw;
  using _fault_comms_dbw_gateway_type =
    bool;
  _fault_comms_dbw_gateway_type fault_comms_dbw_gateway;
  using _fault_comms_dbw_steer_type =
    bool;
  _fault_comms_dbw_steer_type fault_comms_dbw_steer;
  using _fault_comms_dbw_thrtl_type =
    bool;
  _fault_comms_dbw_thrtl_type fault_comms_dbw_thrtl;
  using _fault_comms_dbw_gear_type =
    bool;
  _fault_comms_dbw_gear_type fault_comms_dbw_gear;
  using _fault_comms_vehicle_type =
    bool;
  _fault_comms_vehicle_type fault_comms_vehicle;
  using _fault_comms_actuator_type =
    bool;
  _fault_comms_actuator_type fault_comms_actuator;
  using _fault_comms_actuator_1_type =
    bool;
  _fault_comms_actuator_1_type fault_comms_actuator_1;
  using _fault_comms_actuator_2_type =
    bool;
  _fault_comms_actuator_2_type fault_comms_actuator_2;
  using _fault_vehicle_speed_type =
    bool;
  _fault_vehicle_speed_type fault_vehicle_speed;
  using _fault_actuator_acc_deny_type =
    bool;
  _fault_actuator_acc_deny_type fault_actuator_acc_deny;
  using _fault_actuator_pedal_sensor_type =
    bool;
  _fault_actuator_pedal_sensor_type fault_actuator_pedal_sensor;
  using _fault_bped_sensor_1_type =
    bool;
  _fault_bped_sensor_1_type fault_bped_sensor_1;
  using _fault_bped_sensor_2_type =
    bool;
  _fault_bped_sensor_2_type fault_bped_sensor_2;
  using _fault_bped_sensor_mismatch_type =
    bool;
  _fault_bped_sensor_mismatch_type fault_bped_sensor_mismatch;
  using _fault_actuator_1_type =
    bool;
  _fault_actuator_1_type fault_actuator_1;
  using _fault_actuator_2_type =
    bool;
  _fault_actuator_2_type fault_actuator_2;
  using _fault_control_performance_type =
    bool;
  _fault_control_performance_type fault_control_performance;
  using _fault_param_mismatch_type =
    bool;
  _fault_param_mismatch_type fault_param_mismatch;
  using _fault_param_limits_type =
    bool;
  _fault_param_limits_type fault_param_limits;
  using _fault_calibration_type =
    bool;
  _fault_calibration_type fault_calibration;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__degraded(
    const bool & _arg)
  {
    this->degraded = _arg;
    return *this;
  }
  Type & set__degraded_cmd_type(
    const bool & _arg)
  {
    this->degraded_cmd_type = _arg;
    return *this;
  }
  Type & set__degraded_comms(
    const bool & _arg)
  {
    this->degraded_comms = _arg;
    return *this;
  }
  Type & set__degraded_comms_dbw(
    const bool & _arg)
  {
    this->degraded_comms_dbw = _arg;
    return *this;
  }
  Type & set__degraded_comms_dbw_gateway(
    const bool & _arg)
  {
    this->degraded_comms_dbw_gateway = _arg;
    return *this;
  }
  Type & set__degraded_comms_dbw_steer(
    const bool & _arg)
  {
    this->degraded_comms_dbw_steer = _arg;
    return *this;
  }
  Type & set__degraded_comms_dbw_thrtl(
    const bool & _arg)
  {
    this->degraded_comms_dbw_thrtl = _arg;
    return *this;
  }
  Type & set__degraded_comms_dbw_gear(
    const bool & _arg)
  {
    this->degraded_comms_dbw_gear = _arg;
    return *this;
  }
  Type & set__degraded_comms_vehicle(
    const bool & _arg)
  {
    this->degraded_comms_vehicle = _arg;
    return *this;
  }
  Type & set__degraded_comms_actuator(
    const bool & _arg)
  {
    this->degraded_comms_actuator = _arg;
    return *this;
  }
  Type & set__degraded_comms_actuator_1(
    const bool & _arg)
  {
    this->degraded_comms_actuator_1 = _arg;
    return *this;
  }
  Type & set__degraded_comms_actuator_2(
    const bool & _arg)
  {
    this->degraded_comms_actuator_2 = _arg;
    return *this;
  }
  Type & set__degraded_internal(
    const bool & _arg)
  {
    this->degraded_internal = _arg;
    return *this;
  }
  Type & set__degraded_control_performance(
    const bool & _arg)
  {
    this->degraded_control_performance = _arg;
    return *this;
  }
  Type & set__degraded_param_mismatch(
    const bool & _arg)
  {
    this->degraded_param_mismatch = _arg;
    return *this;
  }
  Type & set__degraded_btsi_stuck_low(
    const bool & _arg)
  {
    this->degraded_btsi_stuck_low = _arg;
    return *this;
  }
  Type & set__degraded_btsi_stuck_high(
    const bool & _arg)
  {
    this->degraded_btsi_stuck_high = _arg;
    return *this;
  }
  Type & set__degraded_vehicle(
    const bool & _arg)
  {
    this->degraded_vehicle = _arg;
    return *this;
  }
  Type & set__degraded_vehicle_speed(
    const bool & _arg)
  {
    this->degraded_vehicle_speed = _arg;
    return *this;
  }
  Type & set__degraded_actuator(
    const bool & _arg)
  {
    this->degraded_actuator = _arg;
    return *this;
  }
  Type & set__degraded_actuator_1(
    const bool & _arg)
  {
    this->degraded_actuator_1 = _arg;
    return *this;
  }
  Type & set__degraded_actuator_2(
    const bool & _arg)
  {
    this->degraded_actuator_2 = _arg;
    return *this;
  }
  Type & set__degraded_actuator_aeb_deny(
    const bool & _arg)
  {
    this->degraded_actuator_aeb_deny = _arg;
    return *this;
  }
  Type & set__degraded_calibration(
    const bool & _arg)
  {
    this->degraded_calibration = _arg;
    return *this;
  }
  Type & set__fault(
    const bool & _arg)
  {
    this->fault = _arg;
    return *this;
  }
  Type & set__fault_power(
    const bool & _arg)
  {
    this->fault_power = _arg;
    return *this;
  }
  Type & set__fault_comms(
    const bool & _arg)
  {
    this->fault_comms = _arg;
    return *this;
  }
  Type & set__fault_internal(
    const bool & _arg)
  {
    this->fault_internal = _arg;
    return *this;
  }
  Type & set__fault_vehicle(
    const bool & _arg)
  {
    this->fault_vehicle = _arg;
    return *this;
  }
  Type & set__fault_actuator(
    const bool & _arg)
  {
    this->fault_actuator = _arg;
    return *this;
  }
  Type & set__fault_comms_dbw(
    const bool & _arg)
  {
    this->fault_comms_dbw = _arg;
    return *this;
  }
  Type & set__fault_comms_dbw_gateway(
    const bool & _arg)
  {
    this->fault_comms_dbw_gateway = _arg;
    return *this;
  }
  Type & set__fault_comms_dbw_steer(
    const bool & _arg)
  {
    this->fault_comms_dbw_steer = _arg;
    return *this;
  }
  Type & set__fault_comms_dbw_thrtl(
    const bool & _arg)
  {
    this->fault_comms_dbw_thrtl = _arg;
    return *this;
  }
  Type & set__fault_comms_dbw_gear(
    const bool & _arg)
  {
    this->fault_comms_dbw_gear = _arg;
    return *this;
  }
  Type & set__fault_comms_vehicle(
    const bool & _arg)
  {
    this->fault_comms_vehicle = _arg;
    return *this;
  }
  Type & set__fault_comms_actuator(
    const bool & _arg)
  {
    this->fault_comms_actuator = _arg;
    return *this;
  }
  Type & set__fault_comms_actuator_1(
    const bool & _arg)
  {
    this->fault_comms_actuator_1 = _arg;
    return *this;
  }
  Type & set__fault_comms_actuator_2(
    const bool & _arg)
  {
    this->fault_comms_actuator_2 = _arg;
    return *this;
  }
  Type & set__fault_vehicle_speed(
    const bool & _arg)
  {
    this->fault_vehicle_speed = _arg;
    return *this;
  }
  Type & set__fault_actuator_acc_deny(
    const bool & _arg)
  {
    this->fault_actuator_acc_deny = _arg;
    return *this;
  }
  Type & set__fault_actuator_pedal_sensor(
    const bool & _arg)
  {
    this->fault_actuator_pedal_sensor = _arg;
    return *this;
  }
  Type & set__fault_bped_sensor_1(
    const bool & _arg)
  {
    this->fault_bped_sensor_1 = _arg;
    return *this;
  }
  Type & set__fault_bped_sensor_2(
    const bool & _arg)
  {
    this->fault_bped_sensor_2 = _arg;
    return *this;
  }
  Type & set__fault_bped_sensor_mismatch(
    const bool & _arg)
  {
    this->fault_bped_sensor_mismatch = _arg;
    return *this;
  }
  Type & set__fault_actuator_1(
    const bool & _arg)
  {
    this->fault_actuator_1 = _arg;
    return *this;
  }
  Type & set__fault_actuator_2(
    const bool & _arg)
  {
    this->fault_actuator_2 = _arg;
    return *this;
  }
  Type & set__fault_control_performance(
    const bool & _arg)
  {
    this->fault_control_performance = _arg;
    return *this;
  }
  Type & set__fault_param_mismatch(
    const bool & _arg)
  {
    this->fault_param_mismatch = _arg;
    return *this;
  }
  Type & set__fault_param_limits(
    const bool & _arg)
  {
    this->fault_param_limits = _arg;
    return *this;
  }
  Type & set__fault_calibration(
    const bool & _arg)
  {
    this->fault_calibration = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__BrakeDiagnostics
    std::shared_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__BrakeDiagnostics
    std::shared_ptr<ds_dbw_msgs::msg::BrakeDiagnostics_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BrakeDiagnostics_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->degraded != other.degraded) {
      return false;
    }
    if (this->degraded_cmd_type != other.degraded_cmd_type) {
      return false;
    }
    if (this->degraded_comms != other.degraded_comms) {
      return false;
    }
    if (this->degraded_comms_dbw != other.degraded_comms_dbw) {
      return false;
    }
    if (this->degraded_comms_dbw_gateway != other.degraded_comms_dbw_gateway) {
      return false;
    }
    if (this->degraded_comms_dbw_steer != other.degraded_comms_dbw_steer) {
      return false;
    }
    if (this->degraded_comms_dbw_thrtl != other.degraded_comms_dbw_thrtl) {
      return false;
    }
    if (this->degraded_comms_dbw_gear != other.degraded_comms_dbw_gear) {
      return false;
    }
    if (this->degraded_comms_vehicle != other.degraded_comms_vehicle) {
      return false;
    }
    if (this->degraded_comms_actuator != other.degraded_comms_actuator) {
      return false;
    }
    if (this->degraded_comms_actuator_1 != other.degraded_comms_actuator_1) {
      return false;
    }
    if (this->degraded_comms_actuator_2 != other.degraded_comms_actuator_2) {
      return false;
    }
    if (this->degraded_internal != other.degraded_internal) {
      return false;
    }
    if (this->degraded_control_performance != other.degraded_control_performance) {
      return false;
    }
    if (this->degraded_param_mismatch != other.degraded_param_mismatch) {
      return false;
    }
    if (this->degraded_btsi_stuck_low != other.degraded_btsi_stuck_low) {
      return false;
    }
    if (this->degraded_btsi_stuck_high != other.degraded_btsi_stuck_high) {
      return false;
    }
    if (this->degraded_vehicle != other.degraded_vehicle) {
      return false;
    }
    if (this->degraded_vehicle_speed != other.degraded_vehicle_speed) {
      return false;
    }
    if (this->degraded_actuator != other.degraded_actuator) {
      return false;
    }
    if (this->degraded_actuator_1 != other.degraded_actuator_1) {
      return false;
    }
    if (this->degraded_actuator_2 != other.degraded_actuator_2) {
      return false;
    }
    if (this->degraded_actuator_aeb_deny != other.degraded_actuator_aeb_deny) {
      return false;
    }
    if (this->degraded_calibration != other.degraded_calibration) {
      return false;
    }
    if (this->fault != other.fault) {
      return false;
    }
    if (this->fault_power != other.fault_power) {
      return false;
    }
    if (this->fault_comms != other.fault_comms) {
      return false;
    }
    if (this->fault_internal != other.fault_internal) {
      return false;
    }
    if (this->fault_vehicle != other.fault_vehicle) {
      return false;
    }
    if (this->fault_actuator != other.fault_actuator) {
      return false;
    }
    if (this->fault_comms_dbw != other.fault_comms_dbw) {
      return false;
    }
    if (this->fault_comms_dbw_gateway != other.fault_comms_dbw_gateway) {
      return false;
    }
    if (this->fault_comms_dbw_steer != other.fault_comms_dbw_steer) {
      return false;
    }
    if (this->fault_comms_dbw_thrtl != other.fault_comms_dbw_thrtl) {
      return false;
    }
    if (this->fault_comms_dbw_gear != other.fault_comms_dbw_gear) {
      return false;
    }
    if (this->fault_comms_vehicle != other.fault_comms_vehicle) {
      return false;
    }
    if (this->fault_comms_actuator != other.fault_comms_actuator) {
      return false;
    }
    if (this->fault_comms_actuator_1 != other.fault_comms_actuator_1) {
      return false;
    }
    if (this->fault_comms_actuator_2 != other.fault_comms_actuator_2) {
      return false;
    }
    if (this->fault_vehicle_speed != other.fault_vehicle_speed) {
      return false;
    }
    if (this->fault_actuator_acc_deny != other.fault_actuator_acc_deny) {
      return false;
    }
    if (this->fault_actuator_pedal_sensor != other.fault_actuator_pedal_sensor) {
      return false;
    }
    if (this->fault_bped_sensor_1 != other.fault_bped_sensor_1) {
      return false;
    }
    if (this->fault_bped_sensor_2 != other.fault_bped_sensor_2) {
      return false;
    }
    if (this->fault_bped_sensor_mismatch != other.fault_bped_sensor_mismatch) {
      return false;
    }
    if (this->fault_actuator_1 != other.fault_actuator_1) {
      return false;
    }
    if (this->fault_actuator_2 != other.fault_actuator_2) {
      return false;
    }
    if (this->fault_control_performance != other.fault_control_performance) {
      return false;
    }
    if (this->fault_param_mismatch != other.fault_param_mismatch) {
      return false;
    }
    if (this->fault_param_limits != other.fault_param_limits) {
      return false;
    }
    if (this->fault_calibration != other.fault_calibration) {
      return false;
    }
    return true;
  }
  bool operator!=(const BrakeDiagnostics_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BrakeDiagnostics_

// alias to use template instance with default allocator
using BrakeDiagnostics =
  ds_dbw_msgs::msg::BrakeDiagnostics_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__BRAKE_DIAGNOSTICS__STRUCT_HPP_
