// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from ds_dbw_msgs:msg/BrakeReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__BUILDER_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "ds_dbw_msgs/msg/detail/brake_report__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace ds_dbw_msgs
{

namespace msg
{

namespace builder
{

class Init_BrakeReport_cmd_src
{
public:
  explicit Init_BrakeReport_cmd_src(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  ::ds_dbw_msgs::msg::BrakeReport cmd_src(::ds_dbw_msgs::msg::BrakeReport::_cmd_src_type arg)
  {
    msg_.cmd_src = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_comms_loss_armed
{
public:
  explicit Init_BrakeReport_comms_loss_armed(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_cmd_src comms_loss_armed(::ds_dbw_msgs::msg::BrakeReport::_comms_loss_armed_type arg)
  {
    msg_.comms_loss_armed = std::move(arg);
    return Init_BrakeReport_cmd_src(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_external_button
{
public:
  explicit Init_BrakeReport_external_button(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_comms_loss_armed external_button(::ds_dbw_msgs::msg::BrakeReport::_external_button_type arg)
  {
    msg_.external_button = std::move(arg);
    return Init_BrakeReport_comms_loss_armed(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_req_park_brake
{
public:
  explicit Init_BrakeReport_req_park_brake(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_external_button req_park_brake(::ds_dbw_msgs::msg::BrakeReport::_req_park_brake_type arg)
  {
    msg_.req_park_brake = std::move(arg);
    return Init_BrakeReport_external_button(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_req_shift_park
{
public:
  explicit Init_BrakeReport_req_shift_park(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_req_park_brake req_shift_park(::ds_dbw_msgs::msg::BrakeReport::_req_shift_park_type arg)
  {
    msg_.req_shift_park = std::move(arg);
    return Init_BrakeReport_req_park_brake(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_brake_available_full
{
public:
  explicit Init_BrakeReport_brake_available_full(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_req_shift_park brake_available_full(::ds_dbw_msgs::msg::BrakeReport::_brake_available_full_type arg)
  {
    msg_.brake_available_full = std::move(arg);
    return Init_BrakeReport_req_shift_park(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_brake_available_duration
{
public:
  explicit Init_BrakeReport_brake_available_duration(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_brake_available_full brake_available_duration(::ds_dbw_msgs::msg::BrakeReport::_brake_available_duration_type arg)
  {
    msg_.brake_available_duration = std::move(arg);
    return Init_BrakeReport_brake_available_full(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_limit_value
{
public:
  explicit Init_BrakeReport_limit_value(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_brake_available_duration limit_value(::ds_dbw_msgs::msg::BrakeReport::_limit_value_type arg)
  {
    msg_.limit_value = std::move(arg);
    return Init_BrakeReport_brake_available_duration(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_degraded
{
public:
  explicit Init_BrakeReport_degraded(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_limit_value degraded(::ds_dbw_msgs::msg::BrakeReport::_degraded_type arg)
  {
    msg_.degraded = std::move(arg);
    return Init_BrakeReport_limit_value(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_bad_rc
{
public:
  explicit Init_BrakeReport_bad_rc(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_degraded bad_rc(::ds_dbw_msgs::msg::BrakeReport::_bad_rc_type arg)
  {
    msg_.bad_rc = std::move(arg);
    return Init_BrakeReport_degraded(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_bad_crc
{
public:
  explicit Init_BrakeReport_bad_crc(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_bad_rc bad_crc(::ds_dbw_msgs::msg::BrakeReport::_bad_crc_type arg)
  {
    msg_.bad_crc = std::move(arg);
    return Init_BrakeReport_bad_rc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_fault
{
public:
  explicit Init_BrakeReport_fault(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_bad_crc fault(::ds_dbw_msgs::msg::BrakeReport::_fault_type arg)
  {
    msg_.fault = std::move(arg);
    return Init_BrakeReport_bad_crc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_timeout
{
public:
  explicit Init_BrakeReport_timeout(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_fault timeout(::ds_dbw_msgs::msg::BrakeReport::_timeout_type arg)
  {
    msg_.timeout = std::move(arg);
    return Init_BrakeReport_fault(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_override_latched
{
public:
  explicit Init_BrakeReport_override_latched(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_timeout override_latched(::ds_dbw_msgs::msg::BrakeReport::_override_latched_type arg)
  {
    msg_.override_latched = std::move(arg);
    return Init_BrakeReport_timeout(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_override_other
{
public:
  explicit Init_BrakeReport_override_other(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_override_latched override_other(::ds_dbw_msgs::msg::BrakeReport::_override_other_type arg)
  {
    msg_.override_other = std::move(arg);
    return Init_BrakeReport_override_latched(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_override_active
{
public:
  explicit Init_BrakeReport_override_active(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_override_other override_active(::ds_dbw_msgs::msg::BrakeReport::_override_active_type arg)
  {
    msg_.override_active = std::move(arg);
    return Init_BrakeReport_override_other(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_enabled
{
public:
  explicit Init_BrakeReport_enabled(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_override_active enabled(::ds_dbw_msgs::msg::BrakeReport::_enabled_type arg)
  {
    msg_.enabled = std::move(arg);
    return Init_BrakeReport_override_active(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_ready
{
public:
  explicit Init_BrakeReport_ready(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_enabled ready(::ds_dbw_msgs::msg::BrakeReport::_ready_type arg)
  {
    msg_.ready = std::move(arg);
    return Init_BrakeReport_enabled(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_external_control
{
public:
  explicit Init_BrakeReport_external_control(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_ready external_control(::ds_dbw_msgs::msg::BrakeReport::_external_control_type arg)
  {
    msg_.external_control = std::move(arg);
    return Init_BrakeReport_ready(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_limiting_rate
{
public:
  explicit Init_BrakeReport_limiting_rate(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_external_control limiting_rate(::ds_dbw_msgs::msg::BrakeReport::_limiting_rate_type arg)
  {
    msg_.limiting_rate = std::move(arg);
    return Init_BrakeReport_external_control(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_limiting_value
{
public:
  explicit Init_BrakeReport_limiting_value(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_limiting_rate limiting_value(::ds_dbw_msgs::msg::BrakeReport::_limiting_value_type arg)
  {
    msg_.limiting_value = std::move(arg);
    return Init_BrakeReport_limiting_rate(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_btsi_cmd
{
public:
  explicit Init_BrakeReport_btsi_cmd(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_limiting_value btsi_cmd(::ds_dbw_msgs::msg::BrakeReport::_btsi_cmd_type arg)
  {
    msg_.btsi_cmd = std::move(arg);
    return Init_BrakeReport_limiting_value(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_percent_output
{
public:
  explicit Init_BrakeReport_percent_output(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_btsi_cmd percent_output(::ds_dbw_msgs::msg::BrakeReport::_percent_output_type arg)
  {
    msg_.percent_output = std::move(arg);
    return Init_BrakeReport_btsi_cmd(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_percent_cmd
{
public:
  explicit Init_BrakeReport_percent_cmd(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_percent_output percent_cmd(::ds_dbw_msgs::msg::BrakeReport::_percent_cmd_type arg)
  {
    msg_.percent_cmd = std::move(arg);
    return Init_BrakeReport_percent_output(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_percent_input
{
public:
  explicit Init_BrakeReport_percent_input(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_percent_cmd percent_input(::ds_dbw_msgs::msg::BrakeReport::_percent_input_type arg)
  {
    msg_.percent_input = std::move(arg);
    return Init_BrakeReport_percent_cmd(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_accel_output
{
public:
  explicit Init_BrakeReport_accel_output(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_percent_input accel_output(::ds_dbw_msgs::msg::BrakeReport::_accel_output_type arg)
  {
    msg_.accel_output = std::move(arg);
    return Init_BrakeReport_percent_input(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_accel_cmd
{
public:
  explicit Init_BrakeReport_accel_cmd(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_accel_output accel_cmd(::ds_dbw_msgs::msg::BrakeReport::_accel_cmd_type arg)
  {
    msg_.accel_cmd = std::move(arg);
    return Init_BrakeReport_accel_output(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_torque_output
{
public:
  explicit Init_BrakeReport_torque_output(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_accel_cmd torque_output(::ds_dbw_msgs::msg::BrakeReport::_torque_output_type arg)
  {
    msg_.torque_output = std::move(arg);
    return Init_BrakeReport_accel_cmd(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_torque_cmd
{
public:
  explicit Init_BrakeReport_torque_cmd(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_torque_output torque_cmd(::ds_dbw_msgs::msg::BrakeReport::_torque_cmd_type arg)
  {
    msg_.torque_cmd = std::move(arg);
    return Init_BrakeReport_torque_output(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_torque_input
{
public:
  explicit Init_BrakeReport_torque_input(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_torque_cmd torque_input(::ds_dbw_msgs::msg::BrakeReport::_torque_input_type arg)
  {
    msg_.torque_input = std::move(arg);
    return Init_BrakeReport_torque_cmd(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_pressure_output
{
public:
  explicit Init_BrakeReport_pressure_output(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_torque_input pressure_output(::ds_dbw_msgs::msg::BrakeReport::_pressure_output_type arg)
  {
    msg_.pressure_output = std::move(arg);
    return Init_BrakeReport_torque_input(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_pressure_cmd
{
public:
  explicit Init_BrakeReport_pressure_cmd(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_pressure_output pressure_cmd(::ds_dbw_msgs::msg::BrakeReport::_pressure_cmd_type arg)
  {
    msg_.pressure_cmd = std::move(arg);
    return Init_BrakeReport_pressure_output(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_pressure_input
{
public:
  explicit Init_BrakeReport_pressure_input(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_pressure_cmd pressure_input(::ds_dbw_msgs::msg::BrakeReport::_pressure_input_type arg)
  {
    msg_.pressure_input = std::move(arg);
    return Init_BrakeReport_pressure_cmd(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_cmd_type
{
public:
  explicit Init_BrakeReport_cmd_type(::ds_dbw_msgs::msg::BrakeReport & msg)
  : msg_(msg)
  {}
  Init_BrakeReport_pressure_input cmd_type(::ds_dbw_msgs::msg::BrakeReport::_cmd_type_type arg)
  {
    msg_.cmd_type = std::move(arg);
    return Init_BrakeReport_pressure_input(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

class Init_BrakeReport_header
{
public:
  Init_BrakeReport_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_BrakeReport_cmd_type header(::ds_dbw_msgs::msg::BrakeReport::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_BrakeReport_cmd_type(msg_);
  }

private:
  ::ds_dbw_msgs::msg::BrakeReport msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_dbw_msgs::msg::BrakeReport>()
{
  return ds_dbw_msgs::msg::builder::Init_BrakeReport_header();
}

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__BRAKE_REPORT__BUILDER_HPP_
