// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_dbw_msgs:msg/EcuInfo.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/ecu_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `name`
// Member `version`
// Member `mac_addr`
// Member `config_hash`
// Member `build_date`
// Member `license_date`
// Member `log_filename`
#include "rosidl_runtime_c/string_functions.h"

bool
ds_dbw_msgs__msg__EcuInfo__init(ds_dbw_msgs__msg__EcuInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // version
  if (!rosidl_runtime_c__String__init(&msg->version)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // mac_addr
  if (!rosidl_runtime_c__String__init(&msg->mac_addr)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // config_hash
  if (!rosidl_runtime_c__String__init(&msg->config_hash)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // config_count_modified
  // config_count_configured
  // config_nvm_blank
  // config_nvm_write_pending
  // build_date
  if (!rosidl_runtime_c__String__init(&msg->build_date)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // license_date
  if (!rosidl_runtime_c__String__init(&msg->license_date)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // control_licensed
  // log_filename
  if (!rosidl_runtime_c__String__init(&msg->log_filename)) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
    return false;
  }
  // log_filesystem_present
  // log_fault
  return true;
}

void
ds_dbw_msgs__msg__EcuInfo__fini(ds_dbw_msgs__msg__EcuInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // version
  rosidl_runtime_c__String__fini(&msg->version);
  // mac_addr
  rosidl_runtime_c__String__fini(&msg->mac_addr);
  // config_hash
  rosidl_runtime_c__String__fini(&msg->config_hash);
  // config_count_modified
  // config_count_configured
  // config_nvm_blank
  // config_nvm_write_pending
  // build_date
  rosidl_runtime_c__String__fini(&msg->build_date);
  // license_date
  rosidl_runtime_c__String__fini(&msg->license_date);
  // control_licensed
  // log_filename
  rosidl_runtime_c__String__fini(&msg->log_filename);
  // log_filesystem_present
  // log_fault
}

bool
ds_dbw_msgs__msg__EcuInfo__are_equal(const ds_dbw_msgs__msg__EcuInfo * lhs, const ds_dbw_msgs__msg__EcuInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // version
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->version), &(rhs->version)))
  {
    return false;
  }
  // mac_addr
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->mac_addr), &(rhs->mac_addr)))
  {
    return false;
  }
  // config_hash
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->config_hash), &(rhs->config_hash)))
  {
    return false;
  }
  // config_count_modified
  if (lhs->config_count_modified != rhs->config_count_modified) {
    return false;
  }
  // config_count_configured
  if (lhs->config_count_configured != rhs->config_count_configured) {
    return false;
  }
  // config_nvm_blank
  if (lhs->config_nvm_blank != rhs->config_nvm_blank) {
    return false;
  }
  // config_nvm_write_pending
  if (lhs->config_nvm_write_pending != rhs->config_nvm_write_pending) {
    return false;
  }
  // build_date
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->build_date), &(rhs->build_date)))
  {
    return false;
  }
  // license_date
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->license_date), &(rhs->license_date)))
  {
    return false;
  }
  // control_licensed
  if (lhs->control_licensed != rhs->control_licensed) {
    return false;
  }
  // log_filename
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->log_filename), &(rhs->log_filename)))
  {
    return false;
  }
  // log_filesystem_present
  if (lhs->log_filesystem_present != rhs->log_filesystem_present) {
    return false;
  }
  // log_fault
  if (lhs->log_fault != rhs->log_fault) {
    return false;
  }
  return true;
}

bool
ds_dbw_msgs__msg__EcuInfo__copy(
  const ds_dbw_msgs__msg__EcuInfo * input,
  ds_dbw_msgs__msg__EcuInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // version
  if (!rosidl_runtime_c__String__copy(
      &(input->version), &(output->version)))
  {
    return false;
  }
  // mac_addr
  if (!rosidl_runtime_c__String__copy(
      &(input->mac_addr), &(output->mac_addr)))
  {
    return false;
  }
  // config_hash
  if (!rosidl_runtime_c__String__copy(
      &(input->config_hash), &(output->config_hash)))
  {
    return false;
  }
  // config_count_modified
  output->config_count_modified = input->config_count_modified;
  // config_count_configured
  output->config_count_configured = input->config_count_configured;
  // config_nvm_blank
  output->config_nvm_blank = input->config_nvm_blank;
  // config_nvm_write_pending
  output->config_nvm_write_pending = input->config_nvm_write_pending;
  // build_date
  if (!rosidl_runtime_c__String__copy(
      &(input->build_date), &(output->build_date)))
  {
    return false;
  }
  // license_date
  if (!rosidl_runtime_c__String__copy(
      &(input->license_date), &(output->license_date)))
  {
    return false;
  }
  // control_licensed
  output->control_licensed = input->control_licensed;
  // log_filename
  if (!rosidl_runtime_c__String__copy(
      &(input->log_filename), &(output->log_filename)))
  {
    return false;
  }
  // log_filesystem_present
  output->log_filesystem_present = input->log_filesystem_present;
  // log_fault
  output->log_fault = input->log_fault;
  return true;
}

ds_dbw_msgs__msg__EcuInfo *
ds_dbw_msgs__msg__EcuInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__EcuInfo * msg = (ds_dbw_msgs__msg__EcuInfo *)allocator.allocate(sizeof(ds_dbw_msgs__msg__EcuInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_dbw_msgs__msg__EcuInfo));
  bool success = ds_dbw_msgs__msg__EcuInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_dbw_msgs__msg__EcuInfo__destroy(ds_dbw_msgs__msg__EcuInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_dbw_msgs__msg__EcuInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_dbw_msgs__msg__EcuInfo__Sequence__init(ds_dbw_msgs__msg__EcuInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__EcuInfo * data = NULL;

  if (size) {
    data = (ds_dbw_msgs__msg__EcuInfo *)allocator.zero_allocate(size, sizeof(ds_dbw_msgs__msg__EcuInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_dbw_msgs__msg__EcuInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_dbw_msgs__msg__EcuInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_dbw_msgs__msg__EcuInfo__Sequence__fini(ds_dbw_msgs__msg__EcuInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_dbw_msgs__msg__EcuInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_dbw_msgs__msg__EcuInfo__Sequence *
ds_dbw_msgs__msg__EcuInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__EcuInfo__Sequence * array = (ds_dbw_msgs__msg__EcuInfo__Sequence *)allocator.allocate(sizeof(ds_dbw_msgs__msg__EcuInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_dbw_msgs__msg__EcuInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_dbw_msgs__msg__EcuInfo__Sequence__destroy(ds_dbw_msgs__msg__EcuInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_dbw_msgs__msg__EcuInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_dbw_msgs__msg__EcuInfo__Sequence__are_equal(const ds_dbw_msgs__msg__EcuInfo__Sequence * lhs, const ds_dbw_msgs__msg__EcuInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_dbw_msgs__msg__EcuInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_dbw_msgs__msg__EcuInfo__Sequence__copy(
  const ds_dbw_msgs__msg__EcuInfo__Sequence * input,
  ds_dbw_msgs__msg__EcuInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_dbw_msgs__msg__EcuInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_dbw_msgs__msg__EcuInfo * data =
      (ds_dbw_msgs__msg__EcuInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_dbw_msgs__msg__EcuInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_dbw_msgs__msg__EcuInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_dbw_msgs__msg__EcuInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
