// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_dbw_msgs:msg/MiscCmd.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/misc_cmd__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `turn_signal`
#include "ds_dbw_msgs/msg/detail/turn_signal__functions.h"
// Member `parking_brake`
#include "ds_dbw_msgs/msg/detail/prk_brk_cmd__functions.h"

bool
ds_dbw_msgs__msg__MiscCmd__init(ds_dbw_msgs__msg__MiscCmd * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_dbw_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // turn_signal
  if (!ds_dbw_msgs__msg__TurnSignal__init(&msg->turn_signal)) {
    ds_dbw_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  // parking_brake
  if (!ds_dbw_msgs__msg__PrkBrkCmd__init(&msg->parking_brake)) {
    ds_dbw_msgs__msg__MiscCmd__fini(msg);
    return false;
  }
  return true;
}

void
ds_dbw_msgs__msg__MiscCmd__fini(ds_dbw_msgs__msg__MiscCmd * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // turn_signal
  ds_dbw_msgs__msg__TurnSignal__fini(&msg->turn_signal);
  // parking_brake
  ds_dbw_msgs__msg__PrkBrkCmd__fini(&msg->parking_brake);
}

bool
ds_dbw_msgs__msg__MiscCmd__are_equal(const ds_dbw_msgs__msg__MiscCmd * lhs, const ds_dbw_msgs__msg__MiscCmd * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // turn_signal
  if (!ds_dbw_msgs__msg__TurnSignal__are_equal(
      &(lhs->turn_signal), &(rhs->turn_signal)))
  {
    return false;
  }
  // parking_brake
  if (!ds_dbw_msgs__msg__PrkBrkCmd__are_equal(
      &(lhs->parking_brake), &(rhs->parking_brake)))
  {
    return false;
  }
  return true;
}

bool
ds_dbw_msgs__msg__MiscCmd__copy(
  const ds_dbw_msgs__msg__MiscCmd * input,
  ds_dbw_msgs__msg__MiscCmd * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // turn_signal
  if (!ds_dbw_msgs__msg__TurnSignal__copy(
      &(input->turn_signal), &(output->turn_signal)))
  {
    return false;
  }
  // parking_brake
  if (!ds_dbw_msgs__msg__PrkBrkCmd__copy(
      &(input->parking_brake), &(output->parking_brake)))
  {
    return false;
  }
  return true;
}

ds_dbw_msgs__msg__MiscCmd *
ds_dbw_msgs__msg__MiscCmd__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__MiscCmd * msg = (ds_dbw_msgs__msg__MiscCmd *)allocator.allocate(sizeof(ds_dbw_msgs__msg__MiscCmd), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_dbw_msgs__msg__MiscCmd));
  bool success = ds_dbw_msgs__msg__MiscCmd__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_dbw_msgs__msg__MiscCmd__destroy(ds_dbw_msgs__msg__MiscCmd * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_dbw_msgs__msg__MiscCmd__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_dbw_msgs__msg__MiscCmd__Sequence__init(ds_dbw_msgs__msg__MiscCmd__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__MiscCmd * data = NULL;

  if (size) {
    data = (ds_dbw_msgs__msg__MiscCmd *)allocator.zero_allocate(size, sizeof(ds_dbw_msgs__msg__MiscCmd), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_dbw_msgs__msg__MiscCmd__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_dbw_msgs__msg__MiscCmd__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_dbw_msgs__msg__MiscCmd__Sequence__fini(ds_dbw_msgs__msg__MiscCmd__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_dbw_msgs__msg__MiscCmd__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_dbw_msgs__msg__MiscCmd__Sequence *
ds_dbw_msgs__msg__MiscCmd__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__MiscCmd__Sequence * array = (ds_dbw_msgs__msg__MiscCmd__Sequence *)allocator.allocate(sizeof(ds_dbw_msgs__msg__MiscCmd__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_dbw_msgs__msg__MiscCmd__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_dbw_msgs__msg__MiscCmd__Sequence__destroy(ds_dbw_msgs__msg__MiscCmd__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_dbw_msgs__msg__MiscCmd__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_dbw_msgs__msg__MiscCmd__Sequence__are_equal(const ds_dbw_msgs__msg__MiscCmd__Sequence * lhs, const ds_dbw_msgs__msg__MiscCmd__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_dbw_msgs__msg__MiscCmd__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_dbw_msgs__msg__MiscCmd__Sequence__copy(
  const ds_dbw_msgs__msg__MiscCmd__Sequence * input,
  ds_dbw_msgs__msg__MiscCmd__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_dbw_msgs__msg__MiscCmd);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_dbw_msgs__msg__MiscCmd * data =
      (ds_dbw_msgs__msg__MiscCmd *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_dbw_msgs__msg__MiscCmd__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_dbw_msgs__msg__MiscCmd__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_dbw_msgs__msg__MiscCmd__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
