// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_dbw_msgs:msg/MonitorThrottle.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__MONITOR_THROTTLE__TRAITS_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__MONITOR_THROTTLE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_dbw_msgs/msg/detail/monitor_throttle__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'pedal_qf'
#include "ds_dbw_msgs/msg/detail/quality__traits.hpp"

namespace ds_dbw_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MonitorThrottle & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: pedal_pc
  {
    out << "pedal_pc: ";
    rosidl_generator_traits::value_to_yaml(msg.pedal_pc, out);
    out << ", ";
  }

  // member: pedal_qf
  {
    out << "pedal_qf: ";
    to_flow_style_yaml(msg.pedal_qf, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MonitorThrottle & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: pedal_pc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedal_pc: ";
    rosidl_generator_traits::value_to_yaml(msg.pedal_pc, out);
    out << "\n";
  }

  // member: pedal_qf
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pedal_qf:\n";
    to_block_style_yaml(msg.pedal_qf, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MonitorThrottle & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_dbw_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_dbw_msgs::msg::MonitorThrottle & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_dbw_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_dbw_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ds_dbw_msgs::msg::MonitorThrottle & msg)
{
  return ds_dbw_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ds_dbw_msgs::msg::MonitorThrottle>()
{
  return "ds_dbw_msgs::msg::MonitorThrottle";
}

template<>
inline const char * name<ds_dbw_msgs::msg::MonitorThrottle>()
{
  return "ds_dbw_msgs/msg/MonitorThrottle";
}

template<>
struct has_fixed_size<ds_dbw_msgs::msg::MonitorThrottle>
  : std::integral_constant<bool, has_fixed_size<ds_dbw_msgs::msg::Quality>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<ds_dbw_msgs::msg::MonitorThrottle>
  : std::integral_constant<bool, has_bounded_size<ds_dbw_msgs::msg::Quality>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<ds_dbw_msgs::msg::MonitorThrottle>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DS_DBW_MSGS__MSG__DETAIL__MONITOR_THROTTLE__TRAITS_HPP_
