// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_dbw_msgs:msg/SteeringReport.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/steering_report__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `cmd_src`
#include "ds_dbw_msgs/msg/detail/cmd_src__functions.h"

bool
ds_dbw_msgs__msg__SteeringReport__init(ds_dbw_msgs__msg__SteeringReport * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_dbw_msgs__msg__SteeringReport__fini(msg);
    return false;
  }
  // steering_wheel_angle
  // steering_column_torque
  // cmd
  // cmd_type
  // limiting_value
  // limiting_rate
  // external_control
  // ready
  // enabled
  // override_active
  // override_other
  // override_latched
  // timeout
  // fault
  // bad_crc
  // bad_rc
  // degraded
  // limit_rate
  // limit_value
  // cmd_src
  if (!ds_dbw_msgs__msg__CmdSrc__init(&msg->cmd_src)) {
    ds_dbw_msgs__msg__SteeringReport__fini(msg);
    return false;
  }
  return true;
}

void
ds_dbw_msgs__msg__SteeringReport__fini(ds_dbw_msgs__msg__SteeringReport * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // steering_wheel_angle
  // steering_column_torque
  // cmd
  // cmd_type
  // limiting_value
  // limiting_rate
  // external_control
  // ready
  // enabled
  // override_active
  // override_other
  // override_latched
  // timeout
  // fault
  // bad_crc
  // bad_rc
  // degraded
  // limit_rate
  // limit_value
  // cmd_src
  ds_dbw_msgs__msg__CmdSrc__fini(&msg->cmd_src);
}

bool
ds_dbw_msgs__msg__SteeringReport__are_equal(const ds_dbw_msgs__msg__SteeringReport * lhs, const ds_dbw_msgs__msg__SteeringReport * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // steering_wheel_angle
  if (lhs->steering_wheel_angle != rhs->steering_wheel_angle) {
    return false;
  }
  // steering_column_torque
  if (lhs->steering_column_torque != rhs->steering_column_torque) {
    return false;
  }
  // cmd
  if (lhs->cmd != rhs->cmd) {
    return false;
  }
  // cmd_type
  if (lhs->cmd_type != rhs->cmd_type) {
    return false;
  }
  // limiting_value
  if (lhs->limiting_value != rhs->limiting_value) {
    return false;
  }
  // limiting_rate
  if (lhs->limiting_rate != rhs->limiting_rate) {
    return false;
  }
  // external_control
  if (lhs->external_control != rhs->external_control) {
    return false;
  }
  // ready
  if (lhs->ready != rhs->ready) {
    return false;
  }
  // enabled
  if (lhs->enabled != rhs->enabled) {
    return false;
  }
  // override_active
  if (lhs->override_active != rhs->override_active) {
    return false;
  }
  // override_other
  if (lhs->override_other != rhs->override_other) {
    return false;
  }
  // override_latched
  if (lhs->override_latched != rhs->override_latched) {
    return false;
  }
  // timeout
  if (lhs->timeout != rhs->timeout) {
    return false;
  }
  // fault
  if (lhs->fault != rhs->fault) {
    return false;
  }
  // bad_crc
  if (lhs->bad_crc != rhs->bad_crc) {
    return false;
  }
  // bad_rc
  if (lhs->bad_rc != rhs->bad_rc) {
    return false;
  }
  // degraded
  if (lhs->degraded != rhs->degraded) {
    return false;
  }
  // limit_rate
  if (lhs->limit_rate != rhs->limit_rate) {
    return false;
  }
  // limit_value
  if (lhs->limit_value != rhs->limit_value) {
    return false;
  }
  // cmd_src
  if (!ds_dbw_msgs__msg__CmdSrc__are_equal(
      &(lhs->cmd_src), &(rhs->cmd_src)))
  {
    return false;
  }
  return true;
}

bool
ds_dbw_msgs__msg__SteeringReport__copy(
  const ds_dbw_msgs__msg__SteeringReport * input,
  ds_dbw_msgs__msg__SteeringReport * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // steering_wheel_angle
  output->steering_wheel_angle = input->steering_wheel_angle;
  // steering_column_torque
  output->steering_column_torque = input->steering_column_torque;
  // cmd
  output->cmd = input->cmd;
  // cmd_type
  output->cmd_type = input->cmd_type;
  // limiting_value
  output->limiting_value = input->limiting_value;
  // limiting_rate
  output->limiting_rate = input->limiting_rate;
  // external_control
  output->external_control = input->external_control;
  // ready
  output->ready = input->ready;
  // enabled
  output->enabled = input->enabled;
  // override_active
  output->override_active = input->override_active;
  // override_other
  output->override_other = input->override_other;
  // override_latched
  output->override_latched = input->override_latched;
  // timeout
  output->timeout = input->timeout;
  // fault
  output->fault = input->fault;
  // bad_crc
  output->bad_crc = input->bad_crc;
  // bad_rc
  output->bad_rc = input->bad_rc;
  // degraded
  output->degraded = input->degraded;
  // limit_rate
  output->limit_rate = input->limit_rate;
  // limit_value
  output->limit_value = input->limit_value;
  // cmd_src
  if (!ds_dbw_msgs__msg__CmdSrc__copy(
      &(input->cmd_src), &(output->cmd_src)))
  {
    return false;
  }
  return true;
}

ds_dbw_msgs__msg__SteeringReport *
ds_dbw_msgs__msg__SteeringReport__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__SteeringReport * msg = (ds_dbw_msgs__msg__SteeringReport *)allocator.allocate(sizeof(ds_dbw_msgs__msg__SteeringReport), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_dbw_msgs__msg__SteeringReport));
  bool success = ds_dbw_msgs__msg__SteeringReport__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_dbw_msgs__msg__SteeringReport__destroy(ds_dbw_msgs__msg__SteeringReport * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_dbw_msgs__msg__SteeringReport__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_dbw_msgs__msg__SteeringReport__Sequence__init(ds_dbw_msgs__msg__SteeringReport__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__SteeringReport * data = NULL;

  if (size) {
    data = (ds_dbw_msgs__msg__SteeringReport *)allocator.zero_allocate(size, sizeof(ds_dbw_msgs__msg__SteeringReport), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_dbw_msgs__msg__SteeringReport__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_dbw_msgs__msg__SteeringReport__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_dbw_msgs__msg__SteeringReport__Sequence__fini(ds_dbw_msgs__msg__SteeringReport__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_dbw_msgs__msg__SteeringReport__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_dbw_msgs__msg__SteeringReport__Sequence *
ds_dbw_msgs__msg__SteeringReport__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__SteeringReport__Sequence * array = (ds_dbw_msgs__msg__SteeringReport__Sequence *)allocator.allocate(sizeof(ds_dbw_msgs__msg__SteeringReport__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_dbw_msgs__msg__SteeringReport__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_dbw_msgs__msg__SteeringReport__Sequence__destroy(ds_dbw_msgs__msg__SteeringReport__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_dbw_msgs__msg__SteeringReport__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_dbw_msgs__msg__SteeringReport__Sequence__are_equal(const ds_dbw_msgs__msg__SteeringReport__Sequence * lhs, const ds_dbw_msgs__msg__SteeringReport__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_dbw_msgs__msg__SteeringReport__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_dbw_msgs__msg__SteeringReport__Sequence__copy(
  const ds_dbw_msgs__msg__SteeringReport__Sequence * input,
  ds_dbw_msgs__msg__SteeringReport__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_dbw_msgs__msg__SteeringReport);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_dbw_msgs__msg__SteeringReport * data =
      (ds_dbw_msgs__msg__SteeringReport *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_dbw_msgs__msg__SteeringReport__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_dbw_msgs__msg__SteeringReport__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_dbw_msgs__msg__SteeringReport__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
