// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_dbw_msgs:msg/EcuInfo.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__TRAITS_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_dbw_msgs/msg/detail/ecu_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace ds_dbw_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EcuInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: version
  {
    out << "version: ";
    rosidl_generator_traits::value_to_yaml(msg.version, out);
    out << ", ";
  }

  // member: mac_addr
  {
    out << "mac_addr: ";
    rosidl_generator_traits::value_to_yaml(msg.mac_addr, out);
    out << ", ";
  }

  // member: config_hash
  {
    out << "config_hash: ";
    rosidl_generator_traits::value_to_yaml(msg.config_hash, out);
    out << ", ";
  }

  // member: config_count_modified
  {
    out << "config_count_modified: ";
    rosidl_generator_traits::value_to_yaml(msg.config_count_modified, out);
    out << ", ";
  }

  // member: config_count_configured
  {
    out << "config_count_configured: ";
    rosidl_generator_traits::value_to_yaml(msg.config_count_configured, out);
    out << ", ";
  }

  // member: config_nvm_blank
  {
    out << "config_nvm_blank: ";
    rosidl_generator_traits::value_to_yaml(msg.config_nvm_blank, out);
    out << ", ";
  }

  // member: config_nvm_write_pending
  {
    out << "config_nvm_write_pending: ";
    rosidl_generator_traits::value_to_yaml(msg.config_nvm_write_pending, out);
    out << ", ";
  }

  // member: build_date
  {
    out << "build_date: ";
    rosidl_generator_traits::value_to_yaml(msg.build_date, out);
    out << ", ";
  }

  // member: license_date
  {
    out << "license_date: ";
    rosidl_generator_traits::value_to_yaml(msg.license_date, out);
    out << ", ";
  }

  // member: control_licensed
  {
    out << "control_licensed: ";
    rosidl_generator_traits::value_to_yaml(msg.control_licensed, out);
    out << ", ";
  }

  // member: log_filename
  {
    out << "log_filename: ";
    rosidl_generator_traits::value_to_yaml(msg.log_filename, out);
    out << ", ";
  }

  // member: log_filesystem_present
  {
    out << "log_filesystem_present: ";
    rosidl_generator_traits::value_to_yaml(msg.log_filesystem_present, out);
    out << ", ";
  }

  // member: log_fault
  {
    out << "log_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.log_fault, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EcuInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "version: ";
    rosidl_generator_traits::value_to_yaml(msg.version, out);
    out << "\n";
  }

  // member: mac_addr
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mac_addr: ";
    rosidl_generator_traits::value_to_yaml(msg.mac_addr, out);
    out << "\n";
  }

  // member: config_hash
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "config_hash: ";
    rosidl_generator_traits::value_to_yaml(msg.config_hash, out);
    out << "\n";
  }

  // member: config_count_modified
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "config_count_modified: ";
    rosidl_generator_traits::value_to_yaml(msg.config_count_modified, out);
    out << "\n";
  }

  // member: config_count_configured
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "config_count_configured: ";
    rosidl_generator_traits::value_to_yaml(msg.config_count_configured, out);
    out << "\n";
  }

  // member: config_nvm_blank
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "config_nvm_blank: ";
    rosidl_generator_traits::value_to_yaml(msg.config_nvm_blank, out);
    out << "\n";
  }

  // member: config_nvm_write_pending
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "config_nvm_write_pending: ";
    rosidl_generator_traits::value_to_yaml(msg.config_nvm_write_pending, out);
    out << "\n";
  }

  // member: build_date
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "build_date: ";
    rosidl_generator_traits::value_to_yaml(msg.build_date, out);
    out << "\n";
  }

  // member: license_date
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "license_date: ";
    rosidl_generator_traits::value_to_yaml(msg.license_date, out);
    out << "\n";
  }

  // member: control_licensed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "control_licensed: ";
    rosidl_generator_traits::value_to_yaml(msg.control_licensed, out);
    out << "\n";
  }

  // member: log_filename
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "log_filename: ";
    rosidl_generator_traits::value_to_yaml(msg.log_filename, out);
    out << "\n";
  }

  // member: log_filesystem_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "log_filesystem_present: ";
    rosidl_generator_traits::value_to_yaml(msg.log_filesystem_present, out);
    out << "\n";
  }

  // member: log_fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "log_fault: ";
    rosidl_generator_traits::value_to_yaml(msg.log_fault, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EcuInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_dbw_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_dbw_msgs::msg::EcuInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_dbw_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_dbw_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ds_dbw_msgs::msg::EcuInfo & msg)
{
  return ds_dbw_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ds_dbw_msgs::msg::EcuInfo>()
{
  return "ds_dbw_msgs::msg::EcuInfo";
}

template<>
inline const char * name<ds_dbw_msgs::msg::EcuInfo>()
{
  return "ds_dbw_msgs/msg/EcuInfo";
}

template<>
struct has_fixed_size<ds_dbw_msgs::msg::EcuInfo>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<ds_dbw_msgs::msg::EcuInfo>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<ds_dbw_msgs::msg::EcuInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DS_DBW_MSGS__MSG__DETAIL__ECU_INFO__TRAITS_HPP_
