// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from ds_dbw_msgs:msg/SteeringDiagnostics.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__STEERING_DIAGNOSTICS__BUILDER_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__STEERING_DIAGNOSTICS__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "ds_dbw_msgs/msg/detail/steering_diagnostics__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace ds_dbw_msgs
{

namespace msg
{

namespace builder
{

class Init_SteeringDiagnostics_fault_calibration
{
public:
  explicit Init_SteeringDiagnostics_fault_calibration(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  ::ds_dbw_msgs::msg::SteeringDiagnostics fault_calibration(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_calibration_type arg)
  {
    msg_.fault_calibration = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_param_limits
{
public:
  explicit Init_SteeringDiagnostics_fault_param_limits(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_calibration fault_param_limits(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_param_limits_type arg)
  {
    msg_.fault_param_limits = std::move(arg);
    return Init_SteeringDiagnostics_fault_calibration(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_param_mismatch
{
public:
  explicit Init_SteeringDiagnostics_fault_param_mismatch(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_param_limits fault_param_mismatch(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_param_mismatch_type arg)
  {
    msg_.fault_param_mismatch = std::move(arg);
    return Init_SteeringDiagnostics_fault_param_limits(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_control_performance
{
public:
  explicit Init_SteeringDiagnostics_fault_control_performance(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_param_mismatch fault_control_performance(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_control_performance_type arg)
  {
    msg_.fault_control_performance = std::move(arg);
    return Init_SteeringDiagnostics_fault_param_mismatch(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_actuator_assist
{
public:
  explicit Init_SteeringDiagnostics_fault_actuator_assist(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_control_performance fault_actuator_assist(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_actuator_assist_type arg)
  {
    msg_.fault_actuator_assist = std::move(arg);
    return Init_SteeringDiagnostics_fault_control_performance(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_actuator_config
{
public:
  explicit Init_SteeringDiagnostics_fault_actuator_config(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_actuator_assist fault_actuator_config(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_actuator_config_type arg)
  {
    msg_.fault_actuator_config = std::move(arg);
    return Init_SteeringDiagnostics_fault_actuator_assist(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_actuator_torque_sensor
{
public:
  explicit Init_SteeringDiagnostics_fault_actuator_torque_sensor(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_actuator_config fault_actuator_torque_sensor(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_actuator_torque_sensor_type arg)
  {
    msg_.fault_actuator_torque_sensor = std::move(arg);
    return Init_SteeringDiagnostics_fault_actuator_config(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_actuator
{
public:
  explicit Init_SteeringDiagnostics_fault_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_actuator_torque_sensor fault_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_actuator_type arg)
  {
    msg_.fault_actuator = std::move(arg);
    return Init_SteeringDiagnostics_fault_actuator_torque_sensor(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_torque_sensor_mismatch
{
public:
  explicit Init_SteeringDiagnostics_fault_torque_sensor_mismatch(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_actuator fault_torque_sensor_mismatch(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_torque_sensor_mismatch_type arg)
  {
    msg_.fault_torque_sensor_mismatch = std::move(arg);
    return Init_SteeringDiagnostics_fault_actuator(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_torque_sensor_2
{
public:
  explicit Init_SteeringDiagnostics_fault_torque_sensor_2(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_torque_sensor_mismatch fault_torque_sensor_2(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_torque_sensor_2_type arg)
  {
    msg_.fault_torque_sensor_2 = std::move(arg);
    return Init_SteeringDiagnostics_fault_torque_sensor_mismatch(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_torque_sensor_1
{
public:
  explicit Init_SteeringDiagnostics_fault_torque_sensor_1(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_torque_sensor_2 fault_torque_sensor_1(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_torque_sensor_1_type arg)
  {
    msg_.fault_torque_sensor_1 = std::move(arg);
    return Init_SteeringDiagnostics_fault_torque_sensor_2(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_angle_sensor
{
public:
  explicit Init_SteeringDiagnostics_fault_angle_sensor(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_torque_sensor_1 fault_angle_sensor(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_angle_sensor_type arg)
  {
    msg_.fault_angle_sensor = std::move(arg);
    return Init_SteeringDiagnostics_fault_torque_sensor_1(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_vehicle_speed
{
public:
  explicit Init_SteeringDiagnostics_fault_vehicle_speed(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_angle_sensor fault_vehicle_speed(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_vehicle_speed_type arg)
  {
    msg_.fault_vehicle_speed = std::move(arg);
    return Init_SteeringDiagnostics_fault_angle_sensor(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_vehicle
{
public:
  explicit Init_SteeringDiagnostics_fault_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_vehicle_speed fault_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_vehicle_type arg)
  {
    msg_.fault_vehicle = std::move(arg);
    return Init_SteeringDiagnostics_fault_vehicle_speed(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_internal
{
public:
  explicit Init_SteeringDiagnostics_fault_internal(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_vehicle fault_internal(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_internal_type arg)
  {
    msg_.fault_internal = std::move(arg);
    return Init_SteeringDiagnostics_fault_vehicle(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms_actuator
{
public:
  explicit Init_SteeringDiagnostics_fault_comms_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_internal fault_comms_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_actuator_type arg)
  {
    msg_.fault_comms_actuator = std::move(arg);
    return Init_SteeringDiagnostics_fault_internal(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms_vehicle
{
public:
  explicit Init_SteeringDiagnostics_fault_comms_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms_actuator fault_comms_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_vehicle_type arg)
  {
    msg_.fault_comms_vehicle = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms_actuator(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms_dbw_gear
{
public:
  explicit Init_SteeringDiagnostics_fault_comms_dbw_gear(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms_vehicle fault_comms_dbw_gear(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_dbw_gear_type arg)
  {
    msg_.fault_comms_dbw_gear = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms_vehicle(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms_dbw_thrtl
{
public:
  explicit Init_SteeringDiagnostics_fault_comms_dbw_thrtl(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms_dbw_gear fault_comms_dbw_thrtl(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_dbw_thrtl_type arg)
  {
    msg_.fault_comms_dbw_thrtl = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms_dbw_gear(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms_dbw_brake
{
public:
  explicit Init_SteeringDiagnostics_fault_comms_dbw_brake(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms_dbw_thrtl fault_comms_dbw_brake(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_dbw_brake_type arg)
  {
    msg_.fault_comms_dbw_brake = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms_dbw_thrtl(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms_dbw_gateway
{
public:
  explicit Init_SteeringDiagnostics_fault_comms_dbw_gateway(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms_dbw_brake fault_comms_dbw_gateway(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_dbw_gateway_type arg)
  {
    msg_.fault_comms_dbw_gateway = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms_dbw_brake(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms_dbw
{
public:
  explicit Init_SteeringDiagnostics_fault_comms_dbw(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms_dbw_gateway fault_comms_dbw(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_dbw_type arg)
  {
    msg_.fault_comms_dbw = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms_dbw_gateway(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_comms
{
public:
  explicit Init_SteeringDiagnostics_fault_comms(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms_dbw fault_comms(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_comms_type arg)
  {
    msg_.fault_comms = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms_dbw(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault_power
{
public:
  explicit Init_SteeringDiagnostics_fault_power(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_comms fault_power(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_power_type arg)
  {
    msg_.fault_power = std::move(arg);
    return Init_SteeringDiagnostics_fault_comms(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_fault
{
public:
  explicit Init_SteeringDiagnostics_fault(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault_power fault(::ds_dbw_msgs::msg::SteeringDiagnostics::_fault_type arg)
  {
    msg_.fault = std::move(arg);
    return Init_SteeringDiagnostics_fault_power(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_calibration
{
public:
  explicit Init_SteeringDiagnostics_degraded_calibration(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_fault degraded_calibration(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_calibration_type arg)
  {
    msg_.degraded_calibration = std::move(arg);
    return Init_SteeringDiagnostics_fault(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_vehicle_speed
{
public:
  explicit Init_SteeringDiagnostics_degraded_vehicle_speed(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_calibration degraded_vehicle_speed(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_vehicle_speed_type arg)
  {
    msg_.degraded_vehicle_speed = std::move(arg);
    return Init_SteeringDiagnostics_degraded_calibration(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_actuator
{
public:
  explicit Init_SteeringDiagnostics_degraded_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_vehicle_speed degraded_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_actuator_type arg)
  {
    msg_.degraded_actuator = std::move(arg);
    return Init_SteeringDiagnostics_degraded_vehicle_speed(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_vehicle
{
public:
  explicit Init_SteeringDiagnostics_degraded_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_actuator degraded_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_vehicle_type arg)
  {
    msg_.degraded_vehicle = std::move(arg);
    return Init_SteeringDiagnostics_degraded_actuator(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_param_mismatch
{
public:
  explicit Init_SteeringDiagnostics_degraded_param_mismatch(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_vehicle degraded_param_mismatch(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_param_mismatch_type arg)
  {
    msg_.degraded_param_mismatch = std::move(arg);
    return Init_SteeringDiagnostics_degraded_vehicle(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_control_performance
{
public:
  explicit Init_SteeringDiagnostics_degraded_control_performance(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_param_mismatch degraded_control_performance(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_control_performance_type arg)
  {
    msg_.degraded_control_performance = std::move(arg);
    return Init_SteeringDiagnostics_degraded_param_mismatch(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_internal
{
public:
  explicit Init_SteeringDiagnostics_degraded_internal(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_control_performance degraded_internal(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_internal_type arg)
  {
    msg_.degraded_internal = std::move(arg);
    return Init_SteeringDiagnostics_degraded_control_performance(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms_actuator
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_internal degraded_comms_actuator(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_actuator_type arg)
  {
    msg_.degraded_comms_actuator = std::move(arg);
    return Init_SteeringDiagnostics_degraded_internal(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms_vehicle
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms_actuator degraded_comms_vehicle(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_vehicle_type arg)
  {
    msg_.degraded_comms_vehicle = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms_actuator(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms_dbw_gear
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms_dbw_gear(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms_vehicle degraded_comms_dbw_gear(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_dbw_gear_type arg)
  {
    msg_.degraded_comms_dbw_gear = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms_vehicle(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms_dbw_thrtl
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms_dbw_thrtl(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms_dbw_gear degraded_comms_dbw_thrtl(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_dbw_thrtl_type arg)
  {
    msg_.degraded_comms_dbw_thrtl = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms_dbw_gear(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms_dbw_brake
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms_dbw_brake(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms_dbw_thrtl degraded_comms_dbw_brake(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_dbw_brake_type arg)
  {
    msg_.degraded_comms_dbw_brake = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms_dbw_thrtl(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms_dbw_gateway
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms_dbw_gateway(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms_dbw_brake degraded_comms_dbw_gateway(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_dbw_gateway_type arg)
  {
    msg_.degraded_comms_dbw_gateway = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms_dbw_brake(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms_dbw
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms_dbw(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms_dbw_gateway degraded_comms_dbw(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_dbw_type arg)
  {
    msg_.degraded_comms_dbw = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms_dbw_gateway(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_comms
{
public:
  explicit Init_SteeringDiagnostics_degraded_comms(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms_dbw degraded_comms(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_comms_type arg)
  {
    msg_.degraded_comms = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms_dbw(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded_cmd_type
{
public:
  explicit Init_SteeringDiagnostics_degraded_cmd_type(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_comms degraded_cmd_type(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_cmd_type_type arg)
  {
    msg_.degraded_cmd_type = std::move(arg);
    return Init_SteeringDiagnostics_degraded_comms(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_degraded
{
public:
  explicit Init_SteeringDiagnostics_degraded(::ds_dbw_msgs::msg::SteeringDiagnostics & msg)
  : msg_(msg)
  {}
  Init_SteeringDiagnostics_degraded_cmd_type degraded(::ds_dbw_msgs::msg::SteeringDiagnostics::_degraded_type arg)
  {
    msg_.degraded = std::move(arg);
    return Init_SteeringDiagnostics_degraded_cmd_type(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

class Init_SteeringDiagnostics_header
{
public:
  Init_SteeringDiagnostics_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SteeringDiagnostics_degraded header(::ds_dbw_msgs::msg::SteeringDiagnostics::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_SteeringDiagnostics_degraded(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringDiagnostics msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_dbw_msgs::msg::SteeringDiagnostics>()
{
  return ds_dbw_msgs::msg::builder::Init_SteeringDiagnostics_header();
}

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__STEERING_DIAGNOSTICS__BUILDER_HPP_
