// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from ds_dbw_msgs:msg/SteeringReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__STEERING_REPORT__BUILDER_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__STEERING_REPORT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "ds_dbw_msgs/msg/detail/steering_report__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace ds_dbw_msgs
{

namespace msg
{

namespace builder
{

class Init_SteeringReport_cmd_src
{
public:
  explicit Init_SteeringReport_cmd_src(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  ::ds_dbw_msgs::msg::SteeringReport cmd_src(::ds_dbw_msgs::msg::SteeringReport::_cmd_src_type arg)
  {
    msg_.cmd_src = std::move(arg);
    return std::move(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_limit_value
{
public:
  explicit Init_SteeringReport_limit_value(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_cmd_src limit_value(::ds_dbw_msgs::msg::SteeringReport::_limit_value_type arg)
  {
    msg_.limit_value = std::move(arg);
    return Init_SteeringReport_cmd_src(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_limit_rate
{
public:
  explicit Init_SteeringReport_limit_rate(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_limit_value limit_rate(::ds_dbw_msgs::msg::SteeringReport::_limit_rate_type arg)
  {
    msg_.limit_rate = std::move(arg);
    return Init_SteeringReport_limit_value(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_degraded
{
public:
  explicit Init_SteeringReport_degraded(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_limit_rate degraded(::ds_dbw_msgs::msg::SteeringReport::_degraded_type arg)
  {
    msg_.degraded = std::move(arg);
    return Init_SteeringReport_limit_rate(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_bad_rc
{
public:
  explicit Init_SteeringReport_bad_rc(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_degraded bad_rc(::ds_dbw_msgs::msg::SteeringReport::_bad_rc_type arg)
  {
    msg_.bad_rc = std::move(arg);
    return Init_SteeringReport_degraded(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_bad_crc
{
public:
  explicit Init_SteeringReport_bad_crc(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_bad_rc bad_crc(::ds_dbw_msgs::msg::SteeringReport::_bad_crc_type arg)
  {
    msg_.bad_crc = std::move(arg);
    return Init_SteeringReport_bad_rc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_fault
{
public:
  explicit Init_SteeringReport_fault(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_bad_crc fault(::ds_dbw_msgs::msg::SteeringReport::_fault_type arg)
  {
    msg_.fault = std::move(arg);
    return Init_SteeringReport_bad_crc(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_timeout
{
public:
  explicit Init_SteeringReport_timeout(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_fault timeout(::ds_dbw_msgs::msg::SteeringReport::_timeout_type arg)
  {
    msg_.timeout = std::move(arg);
    return Init_SteeringReport_fault(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_override_latched
{
public:
  explicit Init_SteeringReport_override_latched(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_timeout override_latched(::ds_dbw_msgs::msg::SteeringReport::_override_latched_type arg)
  {
    msg_.override_latched = std::move(arg);
    return Init_SteeringReport_timeout(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_override_other
{
public:
  explicit Init_SteeringReport_override_other(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_override_latched override_other(::ds_dbw_msgs::msg::SteeringReport::_override_other_type arg)
  {
    msg_.override_other = std::move(arg);
    return Init_SteeringReport_override_latched(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_override_active
{
public:
  explicit Init_SteeringReport_override_active(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_override_other override_active(::ds_dbw_msgs::msg::SteeringReport::_override_active_type arg)
  {
    msg_.override_active = std::move(arg);
    return Init_SteeringReport_override_other(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_enabled
{
public:
  explicit Init_SteeringReport_enabled(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_override_active enabled(::ds_dbw_msgs::msg::SteeringReport::_enabled_type arg)
  {
    msg_.enabled = std::move(arg);
    return Init_SteeringReport_override_active(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_ready
{
public:
  explicit Init_SteeringReport_ready(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_enabled ready(::ds_dbw_msgs::msg::SteeringReport::_ready_type arg)
  {
    msg_.ready = std::move(arg);
    return Init_SteeringReport_enabled(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_external_control
{
public:
  explicit Init_SteeringReport_external_control(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_ready external_control(::ds_dbw_msgs::msg::SteeringReport::_external_control_type arg)
  {
    msg_.external_control = std::move(arg);
    return Init_SteeringReport_ready(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_limiting_rate
{
public:
  explicit Init_SteeringReport_limiting_rate(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_external_control limiting_rate(::ds_dbw_msgs::msg::SteeringReport::_limiting_rate_type arg)
  {
    msg_.limiting_rate = std::move(arg);
    return Init_SteeringReport_external_control(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_limiting_value
{
public:
  explicit Init_SteeringReport_limiting_value(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_limiting_rate limiting_value(::ds_dbw_msgs::msg::SteeringReport::_limiting_value_type arg)
  {
    msg_.limiting_value = std::move(arg);
    return Init_SteeringReport_limiting_rate(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_cmd_type
{
public:
  explicit Init_SteeringReport_cmd_type(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_limiting_value cmd_type(::ds_dbw_msgs::msg::SteeringReport::_cmd_type_type arg)
  {
    msg_.cmd_type = std::move(arg);
    return Init_SteeringReport_limiting_value(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_cmd
{
public:
  explicit Init_SteeringReport_cmd(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_cmd_type cmd(::ds_dbw_msgs::msg::SteeringReport::_cmd_type arg)
  {
    msg_.cmd = std::move(arg);
    return Init_SteeringReport_cmd_type(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_steering_column_torque
{
public:
  explicit Init_SteeringReport_steering_column_torque(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_cmd steering_column_torque(::ds_dbw_msgs::msg::SteeringReport::_steering_column_torque_type arg)
  {
    msg_.steering_column_torque = std::move(arg);
    return Init_SteeringReport_cmd(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_steering_wheel_angle
{
public:
  explicit Init_SteeringReport_steering_wheel_angle(::ds_dbw_msgs::msg::SteeringReport & msg)
  : msg_(msg)
  {}
  Init_SteeringReport_steering_column_torque steering_wheel_angle(::ds_dbw_msgs::msg::SteeringReport::_steering_wheel_angle_type arg)
  {
    msg_.steering_wheel_angle = std::move(arg);
    return Init_SteeringReport_steering_column_torque(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

class Init_SteeringReport_header
{
public:
  Init_SteeringReport_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_SteeringReport_steering_wheel_angle header(::ds_dbw_msgs::msg::SteeringReport::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_SteeringReport_steering_wheel_angle(msg_);
  }

private:
  ::ds_dbw_msgs::msg::SteeringReport msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::ds_dbw_msgs::msg::SteeringReport>()
{
  return ds_dbw_msgs::msg::builder::Init_SteeringReport_header();
}

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__STEERING_REPORT__BUILDER_HPP_
